package
{
	import flash.display.*;
	import flash.events.*
	import flash.filters.ConvolutionFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.net.URLRequest;
	import flash.text.*;
	import flash.utils.Timer;
	
	public class Main extends flash.display.Sprite
	{
		private var loader:Loader;
		private var srcBmd:BitmapData;
		private var tmpBmd:BitmapData;
		private var dstBmd:BitmapData;
		private var bitmap:Bitmap;
		private var textField:TextField;
		private var format:TextFormat;
		private var matrix:Matrix;
		private var defaultMatrix:Matrix;
		private var point:Point;
		private var filter:ConvolutionFilter;
		private var timer:Timer;
		[Embed(source="times.ttf", fontFamily="Times New Roman")]
        private var times:String;
        private var fontFamily:String = "Times New Roman";
		
		public function Main():void
		{
			init();
			loadImage();
		}
		private function init():void {
			format = new TextFormat(fontFamily, 36, 0x000000);
			textField = new TextField();
			textField.defaultTextFormat = format;
			textField.embedFonts = true;
			matrix = new Matrix();
			defaultMatrix = new Matrix();
			point = new Point();
			filter = new ConvolutionFilter(3, 3, [0,1,0,1,1,1,0,1,0],4.9,0,true);
			timer = new Timer(40);
			timer.addEventListener(TimerEvent.TIMER, timerHandler);
		}
		private function loadImage():void {
			loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, completeHandler);
			var request:URLRequest = new URLRequest("paper.jpg");
			loader.load(request);
		}
		private function completeHandler(event:Event):void {
			srcBmd = new BitmapData(loader.width, loader.height, true);
			dstBmd = Bitmap(loader.content).bitmapData;
			bitmap = new Bitmap(dstBmd);
			addChild(bitmap);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			timer.start();
		}
		private function keyUpHandler(event:KeyboardEvent):void {
			textField.text = String.fromCharCode(event.charCode);
			//textField.setTextFormat(format);
			matrix.tx = Math.floor(Math.random()*loader.width);
			matrix.ty = Math.floor(Math.random()*loader.height);
			dstBmd.draw(textField,matrix);
		}
		private function timerHandler(event:TimerEvent):void {
			srcBmd.applyFilter(dstBmd, dstBmd.rect, point, filter);
			dstBmd.draw(srcBmd,defaultMatrix,null,BlendMode.DARKEN);
		}
	}
}